import random
import os

flag = os.getenv("FLAG")

class LFSR:
    def __init__(self, seed):
        self.state = [(seed>>_)&1 for _ in range(32)]
    def next(self):
        n = self.state.pop()
        self.state.insert(0, n)
        return n
    def encrypt(self, s):
        ct = b''
        for c in s:
            n = int(''.join(list(map(str,[lfsr.next() for _ in range(8)]))), 2)
            ct+=bytes([c^n])
        return ct

lfsr = LFSR(random.randint(0, 1<<32))
print(lfsr.encrypt(flag).hex())
print(lfsr.encrypt(bytes.fromhex(input("Let me encrypt that for you: "))))
